#ifndef GMTRADE_H
#define GMTRADE_H

#include <stddef.h>
#include "gmtrade_def.h"

#ifdef WIN32
#ifdef GMSDKC_EXPORTS  
#define GM_TRADE_API __declspec(dllexport)
#else
#define GM_TRADE_API __declspec(dllimport)
#endif
#else
#define GM_TRADE_API
#endif

namespace gmtrade
{

	class GM_TRADE_API Trade
	{
	public:
		Trade(const char *token);
		Trade();
		virtual ~Trade();

	public: //

		//ʼ¼
		int start();

		//ֹͣ¼
		void stop();

		//ûtoken
		void set_token(const char *token);

		//÷ַ
		void set_endpoint(const char *serv_addr);


	public: //׺

		int login(const char *account_ids);

		//ѯָ˺״̬
		int get_account_status(const char *account, AccountStatus &as);

		//ѯн˺״̬
		DataArray<AccountStatus>* get_all_account_status();

		//ָί
		Order order_volume(const char *symbol, int volume, int side, int order_type, int position_effect, double price = 0, const char *account = NULL);

		//ֵָί
		Order order_value(const char *symbol, double value, int side, int order_type, int position_effect, double price = 0, const char *account = NULL);

		//ʲָί
		Order order_percent(const char *symbol, double percent, int side, int order_type, int position_effect, double price = 0, const char *account = NULL);

		//ֵĿֲ
		Order order_target_volume(const char *symbol, int volume, int position_side, int order_type, double price = 0, const char *account = NULL);

		//ֵĿֲֶ
		Order order_target_value(const char *symbol, double value, int position_side, int order_type, double price = 0, const char *account = NULL);

		//ֵĿֱֲʲı
		Order order_target_percent(const char *symbol, double percent, int position_side, int order_type, double price = 0, const char *account = NULL);

		//ƽǰпƽֲ
		DataArray<Order>* order_close_all();

		//ίг
		int order_cancel(const char *cl_ord_id, const char *account = NULL);

		//ί
		int order_cancel_all();

		//ίµ
		Order place_order(const char *symbol, int volume, int side, int order_type, int position_effect, double price = 0, int order_duration = 0, int order_qualifier = 0, double stop_price = 0, const char *account = NULL);

		//ѯʽ
		int get_cash(Cash &cash, const char *accounts = NULL);

		//ѯί
		DataArray<Order>* get_orders(const char *account = NULL);

		//ѯδί
		DataArray<Order>* get_unfinished_orders(const char *account = NULL);

		//ѯɽ
		DataArray<ExecRpt>* get_execution_reports(const char *account = NULL);

		//ѯֲ
		DataArray<Position>* get_position(const char *account = NULL);


	public: //¼

		//ίб仯
		virtual void on_order_status(Order *order);
		//ִлر
		virtual void on_execution_report(ExecRpt *rpt);
		//ʵ˺״̬仯
		virtual void on_account_status(AccountStatus *account_status);
		//
		virtual void on_error(int error_code, const char *error_msg);
		//Ѿ
		virtual void on_trade_data_connected();
		//ӶϿ
		virtual void on_trade_data_disconnected();

	};

} //namespace gmtrade

#endif
